---
title: Navigator.xr
slug: Web/API/Navigator/xr
tags:
  - API
  - AR
  - Augmented Reality
  - Getter
  - Graphics
  - Navigator
  - Property
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - XR
---
<div>{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The read-only <code><strong>xr</strong></code> property provided by the {{domxref("Navigator")}} or {{domxref("WorkerNavigator")}} interface returns an {{domxref("XRSystem")}} object which can be used to access the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>xr</var> = navigator.xr</pre>

<h3 id="Value">Value</h3>

<p>The {{domxref("XRSystem")}} object used to interface with the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> in the current context. This can be used to present augmented and/or virtual reality imagery to the user.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>Each {{domxref("Window")}} has its own instance of {{domxref("Navigator")}}, which can be accessed as {{domxref("Window.navigator","window.navigator")}} or as {{domxref("Window.navigator", "navigator")}}. At the same time, a new {{domxref("XRSystem")}} instance is also created and attached to the <code>navigator</code> instance as {{domxref("Navigator.xr", "navigator.xr")}}. If the <code>xr</code> property exists, you can use it to access the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>.</p>

<p>To determine if WebXR is available, you can do something like this:</p>

<pre class="brush: js notranslate">if ("xr" in window.navigator) {
  /* WebXR can be used! */
} else {
  /* WebXR isn't available */
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#navigator-xr-attribute","Navigator.xr")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Navigator.xr")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a>: 2D and 3D accelerated graphics for the web</li>
 <li><a href="/en-US/docs/Web/API/Canvas_API">Canvas API</a>: Easy 2D graphics API</li>
</ul>
